#ifndef GATE_H
#define GATE_H

#include <graphics/mylib.h>
#include <utils/newasm.h>
#include "logdef.h"

typedef struct log_grec {
  struct log_grec *next, *confnext;
  na_long info;
  log_nrec **pin;
  log_pinposrec *pinpos;
  log_gattrrec *attr;
  na_long vars;
  log_krec *kind;
  short g, x, y, gc, sig;
  na_long temp;
  uchar rot;
  unsigned conflict : 1, oconflict : 1, dimcolor : 1, conflict1 : 1,
	   conflict2 : 1, f2 : 1, f1 : 1, f0 : 1;
} log_grec;   /* Gate */

void uaddgate(short x, short y, short gtype);

void addgate1(short x, short y, short gtype);

void pconnectgate(log_grec *gate, int *success);

void delgate(log_grec *gate);

void disconnectgate(log_grec *gate);

void closergate(short x, short y);

void disposegate(log_grec **gate);

void copygate(log_grec *old, log_grec **gate);

void newgate(log_grec **gate, short gt);

void eragate(log_grec *gate);

int addgate(short gtype, short sig, log_gattrrec *attrs);
int insidegate(log_grec *gate, short x, short y);
int connectgate(log_grec *gate);
void linkgate(log_grec **gate);
void newgptr(log_grec **gate);
void newgate2(log_grec **gate, short gt, short sig, log_gattrrec *attrs);
void unlkgate(log_grec **gate);
void disposegptr(log_grec **gate);
void chggate(log_grec *gate, int i, log_nrec *oldnode, log_nrec *n);
void chggatepin(log_grec *gate, short i, log_nrec **oldnode, log_nrec **savenode);
void frygate(log_grec *gate);
void initpinpos(log_grec *gate);
void addgate2(short x, short y, short gtype, short sig, log_gattrrec *attrs);
void movexorgate(short x, short y, short g, short sig, short yy);
void reportgateconflict(log_grec *g);

#endif
