#ifndef LOGGLOBALS
#define LOGGLOBALS

#include <utils/p2c.h>
#include <graphics/newkbd.h>
#include "settings.h"
#include "logstructs.h"
#include "tool.h"

/* 0*/
/* If the pen is in "this" sector, */
/* 1*/
/*   switch to "this" state.       */
/* 2*/
/* 3*/
/* 4*/
/* 5*/
/* 6*/
/* 7*/
/* 8*/
/* 9*/
/*10*/
/*11*/
/*12*/
/*13*/
/*14*/
/*15*/
/*16*/
/*17*/
/*18*/
/*19*/
/*20*/
/*21*/
/*22*/
/*23*/

extern log_action_t gg;   /* External global variables */

extern int rabbits, rabflag;   /* Rabbit mode */
extern int avoidrabbits;

extern short txacross, txdown, across, down, baseline, line1, line2,
                         kindgroupbase, kindgroupleft, kindgroupright, kindgroupstart,
                         kindgroupsize, histdown;

extern int entrycapslock;   /* Capslock status on entry */
extern int oldcapslock;   /* Previous capslock status */

extern int signalcaps;   /* Capslock flag for signal-name entry */
extern int labelcaps;   /* Capslock flag for label entry */

extern char (*index_)[9];   /* Index into gate library */
extern short *indexoffset;   /* Offset of each gate */
extern uchar *indexfile;   /* File number of each gate */
extern uchar *indexgroup;   /* Group number of each gate */
extern uchar *loadedgates;   /* Tells whether a gate is in the catalog */
extern log_krec *kind[maxmaxkinds];   /* Kind of gate in each catalog space */
extern kindgrouptype kindgroup;   /* Kind of gate in each menu-area space */
extern kindgrouptype kindsig;
extern kindattrtype kindattr;
extern strlist_t *gatefilenames;
extern short maxkinds, catwidth;
extern catboxrec *catboxes;

extern char *gatesname[maxgatesfiles];
extern char *loghelpname, *lognewsname;   /* Names of system files */

extern short zoom;   /* Zooming level */
extern int ospointflag;   /* Starting point was touched */

extern long xoff0, yoff0;   /* Old XOFF, YOFF */

extern short curwcolor;   /* Current VLSI wire color */
extern char cureditmode;   /* Current editing (gate-tapping) mode */
extern short curlistgroup;   /* Current group in library list */

extern int vlsimode[log_maxpages];   /* Page contains VLSI circuits */
extern long xoffp[log_maxpages], yoffp[log_maxpages];
/* XOFF, YOFF for non-current pages */
extern short gatecount[log_maxpages];   /* Highest used gate-ID number */
extern char *curfilename[log_maxpages];   /* Name of last-loaded file */
extern long realcurpage;

extern baseptrs copybuf;   /* Del/Copy/Paste buffer */

extern long htcount;   /* Number of timesteps in list */
extern short hncount;   /* Number of names in list */
extern short hnocount;   /* Old number of names in list */
extern short histtrig;   /* Number of signal which triggers history */
extern strlist_t *histlbl;
extern short histnumattrs;
extern log_kattrrec *histkattr;
extern log_gattrrec *histgattr;
extern short histgridmode, histgridwhich;
extern log_hnrec *histgridhn;
extern double histvalrange, histdivsacross;
extern int histonscreen;   /* Leading edge of trace is visible */
extern int histreset;   /* Clear the history memory */
extern double histtime;   /* Current time for history mode */

extern int probeflag;   /* Has the probe been checked? */

extern log_nrec *nodeconflictbase;   /* Node conflict list */
extern log_grec *gateconflictbase;   /* Gate conflict list */

extern cnfrec *cnfbase;   /* List of tool configuration lines */
extern strlist_t *colorbase;   /* List of configured colors */
extern macrorec *macrobase;   /* List of macro keys */
extern strlist_t *thingstodo, *nexttodo;   /* List of delayed commands */
extern strlist_t *messages;   /* List of delayed messages */
extern strlist_t *commandlist;   /* List of tool-activation commands */

extern char modename[9];   /* Word in 'mode' area of menu */
extern int modeflag;   /* Mode area contains a word */
extern long modetime;   /* Time (in minutes) in mode display */
extern log_krec *modeprobekind;

extern nk_keytransinfo *curkeytrans;   /* Current keyboard definitions */

enum cursors { normal, grid, delete__, copy_, paste, boxcursor};
extern enum cursors cursortype;
extern enum cursors oldcursortype;
/* Type of cursor */

/*  menupicture, errorpicture : m_picturevar;              { Various saved images */
extern short bottomcount;   /* How many nested BEGINBOTTOMs */

extern uchar rcolormap[16], gcolormap[16], bcolormap[16];

extern short gategreen, gateyellow, gatered, gateorange, gateblack, gatewhite;

extern short defineboxcolor, definebackcolor, definetextcolor, catboxcolor;

extern short messagepos;   /* Position of next message */
extern short messageright;   /* Maximum width of messages */

extern long fastsavetime;

extern long watchdog, rabtime;   /* Miscellaneous timers */

extern log_tool *simtype_ignore;   /* Non-simulated type */
extern log_tool *simtype_common;   /* Common-pin type */

extern double status_oldtime, status_oldtstep;
extern long status_oldmem;

extern filerecfilerec *libf1[maxgatesfiles];   /* Library files */
extern short libfstart[maxgatesfiles];
/* First descriptor record in LIBF1 */
extern short libptr;   /* Most recently replaced catalog item */
extern short idxsize;   /* Number of gates in library */
extern char *librgroupnames[9];

extern short refrtimer, refrtimer0;   /* Time until screen is refreshed */

extern long tabletaddr;

extern char *dumpfname, *tracefname;
extern FILE *tracefile;

extern char pushedbackkey, realkey;

extern long EXCP_LINE;   /* Line number of last error */
extern long excpline;

extern short conflictdelay;

extern int eightcolors;   /* Has only 8 colors */
extern int onescreen;   /* Has only one screen */
extern int doingcnffunction;   /* This is an ACT_CNF, not an ACT_FUNC */
extern int justonecommand;   /* LOG -R mode, so exit after first cmd */
extern int displaynews;   /* LOGNEWS has not yet been displayed */
extern int immedscroll;   /* Don't need to defer 'REFR' function */
extern int tempverbose;   /* Verbose mode temporarily on */
extern int commandfound;   /* Function name was acknowledged */
extern int cursorhide;   /* Cursor is hidden */
extern int reportnowait;   /* Don't wait for key on bug reports */
extern int firsttraining;   /* Training used for first time */
extern int training;   /* Training mode for Help command */
extern int snapflag;   /* Snap-to-grid cursor */
extern int showsolder;   /* Display solder points */
extern int briefprobe;   /* Temporary probe mode */
extern int conflictenbl;   /* Conflict checking enabled */
extern int conflictstop;   /* Conflict stopping mode */
extern int anyconflicts;   /* Any active, reported conflicts? */
extern int steppingoff;   /* Single-step is turning simulation off */
extern int suppressdots;   /* Temporarily suppressing red dots */
extern int glowsolder;   /* Display solder dots in Glow mode */
extern int vlsi;   /* Current page is VLSI mode */

#endif
