#ifndef LOGSTRUCTS
#define LOGSTRUCTS

#include "settings.h"
#include "logdef.h"

/** ??? */
typedef struct descrec {
        int32_t ptr;
        uchar numvects, numpins, numpnums, lblsize, simtype, procsize;
        /* log_kflags */ short flag;
        schar xx1, yy1, xx2, yy2;
} descrec;

/** 2D vector */
typedef struct ovectorrec {
        schar x1, y1, x2, y2;
} ovectorrec;

/** Union representing a pack of 256 bytes */
typedef union filerec {
        uchar b[256];
        schar sb[256];
        char c[256];
        short sh[128];
        int32_t i[64];
        log_pac8 ix[32];
        ovectorrec vec[64];
        log_pinrec pin[64];
        log_pnumrec pnum[64];
        descrec desc[16];
        log_pac4 c4[64];
} filerec;

typedef struct filerecfilerec {
        FILE *f;
        FILEBUFNC(f,filerec);
} filerecfilerec;

typedef struct rablistrec {
        short x, y, next;
} rablistrec;   /* Rabbit mode state descriptor */

typedef rablistrec rablisttype[rablistsize + 1];

typedef struct rabmusrec {
        short note, time;
} rabmusrec;   /* Rabbit music descriptor */

typedef rabmusrec rabmustype[rabmussize];

typedef short kindgrouptype[kindgroupmaxsize];
typedef log_gattrrec *kindattrtype[kindgroupmaxsize];

/* Index to gate library */

typedef struct logmenurec {
        char name[17];
        char cmd[33];
        int *bool_;
} logmenurec;   /* Pop-up menu options */

/* Pointer to node-combination record */
/* Pointer to temporary solder */
/* Pointer to configuration record */
/* Pointer to macro key record */
/* Pointer to box in catalog page */
/* Pointer to library string record */


typedef struct cnrec {
        log_nrec *n, **np;
        int done;
        struct cnrec *next;
} cnrec;   /* Delayed Combinenodes record */


typedef struct blobrec {
        log_hwrec *hw;
        log_vwrec *vw;
        short x, y;
        struct blobrec *next;
} blobrec;


typedef struct cnfrec {
        char tool[17];
        struct cnfrec *next;
        char s[256];   /*not fully allocated*/
} cnfrec;   /* Tool configuration record */


typedef struct macrorec {
        char key;
        struct macrorec *next;
        char name[33];
} macrorec;   /* Macro key */

typedef struct catboxrec {
        short pos, count;
        struct catboxrec *next;
} catboxrec;   /* yow */


typedef struct librstrrec {
        char name[9];
        char *str;
        struct librstrrec *left, *right;
} librstrrec;


typedef struct baseptrs {
        log_grec *gcopy;
        log_srec *scopy;
        log_hwrec *hwcopy;
        log_vwrec *vwcopy;
        log_lrec *lcopy;
        log_brec *bcopy;
        short x1copy, y1copy, x2copy, y2copy, dxcopy, dycopy, pgnum;
        int valid;
} baseptrs;

#endif
