#ifndef REGEX_H
#define REGEX_H


#include <utils/newasm.h>


#define re_defchars     "\\[]^-*?+$.|~(){}:=<>"
#define re_shellchars   "\\[]^-    ?       *  "

void re_compile (char *ex, char *rex, char *chars);
void re_cicompile (char *ex, char *rex, char *chars);
void re_dump (char *rex);
void re_search (char *s, char *rex, size_t *pos, size_t *last, size_t dir);
int re_compare (char *s, char *rex);
void re_replace (char *s, char *rex, char *rpl, size_t *pos,
			   size_t *last);
int re_matchstr (char *s, char *pat);
int re_matchsubstr (char *s, char *pat, size_t start, size_t *last);
void re_grepl (char *s, char *pat, char *rpl);


#endif /*REGEX_H*/



