#ifndef STRLIST_H
#define STRLIST_H

typedef struct strlist_t
{
	struct strlist_t *next;
	void *value;    /* user-defined */
	char kind;      /* user-defined */
	size_t len;     /* for internal use */
	char *s;
} strlist_t;


void strlist_init (strlist_t **base);
strlist_t *strlist_find (strlist_t *base, char *s);
strlist_t *strlist_cifind (strlist_t *base, char *s);
void strlist_change (strlist_t **base, strlist_t **ptr, char *s);
void strlist_remove (strlist_t **base, char *s);
void strlist_delete (strlist_t **base, strlist_t **ptr);
void strlist_dispose (strlist_t **ptr);
void strlist_empty (strlist_t **base);
void strlist_copy (strlist_t **dest, strlist_t *src);
strlist_t *strlist_add (strlist_t **base, char *s);
strlist_t *strlist_append (strlist_t **base, char *s);
strlist_t *strlist_insert (strlist_t **base, char *s);

void strlist_dump (FILE *f, strlist_t *base);


#endif

